#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

int main(int argc, char *argv[])
{
  FILE *fp;            /*puntero archivo texto*/
  pid_t pid;           /*se define el tipo de la variable pid*/
  char car;            /*define caracter*/
  int pfd[2];
  char *sup;           /*define puntero a caracter*/
  char *inf;
  char msg[8][70];     /*define 8 arreglos de 70 caracteres cada uno, que representan los menajes comunes para todos*/
  char msg2[30][70];   /*define 30 arreglos de 70 caracteres cada uno, reprentan la cantidad mxima de mail pueden ser enviados*/
  int status, cont;   /*variables*/
  int i=0, j=0, k=0, l=0;  /*variables enteras*/

   if(argc!=2){
      printf("Ha olvidado introducir el nombre del archivo.\n"); /*si no se ingresa el argumento o archivo a leer se activa esta lnea*/
      exit(1);
   }

   if((fp=fopen(argv[1],"r"))==NULL){            /*se abre el archivo de texto que se paso como argumento*/
      printf("No se puede abrir el archivo.\n");     /*se abre el archivo en modo lectura*/
      exit(1);
   }

   car = getc(fp);                         /*se lee el primer caracter de el archivo de texto*/

   while (car!=EOF){
                                           /* se examina el primer caracter si es igual a '/' se sigue la sentencia if*/
       if (car=='/'){
          car = getc(fp);                  /*se lee el segundo caracter de el archivo de texto*/

          if(car=='/'){                     /* se examina el segundo caracter si es igual a '/' se sigue la sentencia if*/
             j=0;
              while (car!=EOF && car!='\n'){ /*si llegamos al final del archivo texto paramos al igual que si se trmina la lnea */
                    car = getc(fp);
                    msg[i][j]=car;        /*se lee caracter a caracter y se guarda el resultado en un string o arreglo de caracteres*/
                    j++;
               }
               msg[i][j]='\0';            /*cuando se trmina de leer y almacenar una lnea, se escribe un carcter nulo al final*/
               i++;
           }

      }

      else {                        /*si el primer caracter de una linea no es '/' entonces se ejecuta esta sentencia*/

         if(car!='/'){
           l=0;                    /*en una variable cada uno de las lneas que contienen las direcciones de correo*/
           msg2[k][l]=car;
           l++;

          while (car!='\n'){
            car = getc(fp);         /*esta sintaxis se encarga de almacenar*/
            msg2[k][l]=car;         /*en una variable cada uno de las lneas que contienen las direcciones de correo*/
            l++;
          }
          msg2[k][l]='\0';           /*cuando se trmina de leer y guardar una lnea, se escribe un carcter nulo al final*/
          k++;
        }
     }
     car = getc(fp);
    }

   cont=k-1;                        /*la variable entera cont determina cuantas veces se repite el proceso de enviar mail*/
   for(i=0; i<cont;i++){            /* dependiendo del numero de destinatarios*/

     sup=strtok(msg2[i],"\t");      /*divide cada arreglo que contiene direccion de correo y notas*/
     inf=strtok(NULL,"\0");         /*a variable sup se asigna la direccion de correo, a variable inf se asigna notas respectivas*/


          /*abrimos una tuberia*/
     if (pipe(pfd) < 0) {
        perror("error creando pipe");
        exit(1);
      }

       /*creamos un proceso hijo*/
     if ((pid = fork()) < 0) {
        perror("error fork");
        exit(1);
     }
        /*
     * el proceso hijo ejecuta el comando mail.
     */
     if (pid == 0) {
        /*
         * liga la entraga estandar con el pipe
         */
        dup2(pfd[0], 0);
        close(pfd[1]);

        printf("fueron enviadas las notas a: %s", sup);
        printf("\n");
        execl("/bin/mail", "mail", sup, 0);        /*se ejecuta el comando mail para cada destinatario*/
        perror("exec");
        _exit(127);

        }
       /*
     * no se va a leer desde la pipe (padre)
     */
    close(pfd[0]);

         write(pfd[1], msg[0], strlen(msg[0]));
         write(pfd[1], msg[1], strlen(msg[1]));
         write(pfd[1], msg[2], strlen(msg[2]));    /*se envian los mensajes por mail. Si se quieren enviar nuevos mensajes, se deben agregar sentencias */
         write(pfd[1], inf, strlen(inf));        /*inf parte inferior de un arreglo de caracteres (de e-mail y notas), varia segun destinatario*/
         write(pfd[1], msg[3], strlen(msg[3]));
         write(pfd[1], msg[4], strlen(msg[4]));
         write(pfd[1], ".\n", 5);

    /*
    cierra la pipe
     */
    close(pfd[1]);

    waitpid(pid, &status, 0);   /*espera a que finalice el hijo*/


   }


  fclose(fp);          /*se pone fin a la lectura del archivo texto*/



 }

